var oldTitle = document.title;
var toId;
var contacts = {};
var messageQueue = new Queue();
var chat_window = null;

var errorsInRow = 0;
var tabsToOpen = {};

var shift = function () {
	return -Math.round(new Date().getTimezoneOffset()*60);
}


function changeTitle(){
	
	var newMessages = false;
	for(var id in contacts){
		if(contacts[id].message){
			newMessages = true;
			break;
		}
	}

	if (newMessages){
		if(document.title=='***********'){
			document.title = 'Новое сообщение'
		}else{
			document.title = '***********'
		}	
	}else{
		document.title = oldTitle;
	}
	setTimeout('changeTitle()',500);
}

var getUserName = function(id){
	if(id==MyUserId || contacts[id] == undefined){
		return MyUserName;
	}else{
		return contacts[id].name;
	}
}
	
function contactList(){

	this.update = function(contact, callback){
		
		//обновляем только необходимые нам поля..
		if(!contacts[contact.id]){
			contacts[contact.id] = contact;	
		}else{
			contacts[contact.id].id			= contact.id;
			contacts[contact.id].name		= contact.name;
			contacts[contact.id].list		= contact.list;
			contacts[contact.id].list_id	= contact.list_id;
			
		}
		contacts[contact.id].online		= (contact.online==true)?1:0;
		
		if(callback!=undefined){callback(contact);}
		
	},

	this.remove = function(id, callback){
		delete contacts[id];
		if(callback!=undefined){
			callback(id);
		}
		
	},
	this.updateList = function(callback){
		
		var repeatTime = 20*1000;
		var This = this;
		
		EXIST_USER_IDS = [];
		for(var id in contacts){
			/* if(!EXIST_USER_IDS[contacts[id].list]){
				EXIST_USER_IDS[contacts[id].list] = {};
			}
			var online = (contacts[id].online)?1:0; */
			EXIST_USER_IDS.push(id);//[contacts[id].list][id]=online;
		}

		jQuery_1_9_1.ajax({
			type: "POST",
			url: "/ajax_webmessenger.php",
			data: {
				EXIST_USER_IDS: EXIST_USER_IDS,
				UPDATE_CONTACT_LIST: 'Y'
			},
			dataType: 'json',
			success: function(data){
			
				if(callback!=undefined){ callback(data); }
			
				setTimeout(function() { This.updateList(callback); }, repeatTime);
			},
			error: function(XMLHttpRequest, textStatus, errorThrown){
				setTimeout(function() { This.updateList(callback); }, repeatTime);
			}
		});
	}
	
}

function Queue(){
	var items = [];

	this.size = function(){
		return items.length;
	}
	this.empty = function(){
		return (items.length == 0);
	}
	this.add = function(text, to){
		items.push({
			text: text,
			to: to
		});
	}
	this.getFirst = function(){
		return items[0];
	}
	this.removeFirst = function(){
		items.shift();
	}
}

function client(){
	
	var timestamp = 0;
	
	
	//получает иды пользоватей(вкладок) для котрых есть сообщения
	// на вход ей отдаем тех, у кого и так есть сообщения..
	this.waitForMessages = function(afterSuccess) {
		var This = this;
		var EXIST_IDS = [];
		for(var id in contacts){
			if (contacts[id].message){
				EXIST_IDS.push(id); 
			}
		}
		jQuery_1_9_1.ajax({
			type: "POST",
			url: "/ajax_webmessenger.php",
			dataType: 'json',
			async: true,
			timeout: 30000,
			data: {EXIST_IDS:EXIST_IDS, READ_MESSAGES: 'Y'},
			success: function(data){
				if(data.length){
					if(afterSuccess != undefined) afterSuccess(data);
				}
				This.waitForMessages(afterSuccess);
			},
			error: function(XMLHttpRequest, textStatus, errorThrown){
				This.waitForMessages(afterSuccess);
			}
		});
	}
	  	
	this.getMessages = function(userId, target, before, afterSuccess) {
		
		
			// если чат окно существует и оно видимо
			if(jQuery_1_9_1(target).is('*')){
				
				
				jQuery_1_9_1.ajax({
						beforeSend: function (XMLHttpRequest) {
										if(before != undefined) before();
									},
						type: "POST",
						data: {FROM_USER: userId, GET_MESSAGES: 'Y'},
						url: "/ajax_webmessenger.php",
						dataType: 'json',
						success: function(data){
							

							showMessages(data, userId, target);
								
							contacts[userId].message = false;

							if(afterSuccess != undefined) afterSuccess(data);
						},
						error: function(XMLHttpRequest, textStatus, errorThrown){
							This.getMessages(userId, target, before, afterSuccess);
						}
					});
								
			}

	}

	this.sendMessage = function(before, afterSucces, afterError){
		
		if(messageQueue.empty()) return;

		var message = messageQueue.getFirst();
		
		jQuery_1_9_1.ajax({
			beforeSend: function (XMLHttpRequest) {				
				if(before != undefined) before();
			},
			type: "POST",
			url: "/ajax_webmessenger.php",
			data: {
				MESSAGE_TO: message.to,
				MESSAGE: message.text,
				SEND_MESSAGE: 'Y'
			},
			dataType: 'json',
			success: function(data){
				if(afterSucces != undefined) afterSucces(data);
			},
			error: function(XMLHttpRequest, textStatus, errorThrown){
				if(afterError != undefined) afterError(textStatus);
				setTimeout(function(){This.sendMessage(before, afterSucces, afterError);}, 1000);
			}
		});
		
	}
		
	
	
}


function showMessages(messages, userId, target){
	
	var chatOutput = jQuery_1_9_1(target);
	
	//если есть сообщения
	if(messages && messages.length){
		for(i=0;i<messages.length;i++){
			//если это свое же сообщение
			var messageClass = 'user-to';
			if(MyUserId==messages[i].from || MyUserId==0){
				messageClass = 'user-from';
			}
			
			var nameFrom = getUserName(messages[i].from);

			out = '<div class="message">'+
				'<p><span class="'+messageClass+'"><strong>'+nameFrom+'</strong></span> <span class="date">('+messages[i].time+')</span></p>'+
				'<p class="messageText">'+messages[i].text+'</p>'+
			'</div>';		
			chatOutput.append(out);
							
		}	
		chatOutput.scrollTo("max", {axis: 'y', duration: .2});			
	}	
}


